local GUI = {}
_G["ClassicRaidAssistGUI"] = GUI
_G["ClassicRaidAssistGUI_Shown"] = false
local AceGUI = LibStub("AceGUI-3.0")

LibStub("AceHook-3.0"):Embed(GUI)

local version = GetAddOnMetadata("ClassicRaidAssist", "Version")

local AceGUI = LibStub("AceGUI-3.0")
local frame = nil
local tabGroup = nil

function GUI:ReloadTab()
    tabGroup:SelectTab(ClassicRaidAssist.db.char.currentTab)
end


function GUI:Toggle()
    if(frame:IsShown()) then
        ClassicRaidAssistGUI_Shown = false
        frame:Hide()
    else
        -- refresh tab on toggle in
        ClassicRaidAssistGUI_Shown = true
        tabGroup:SelectTab(ClassicRaidAssist.db.char.currentTab)
        frame:Show()
    end
end

function GUI:DrawSettings(container)
    ClassicRaidAssist:ClearCooldowns()

    local settingsContainer = AceGUI:Create("InlineGroup")
    settingsContainer:SetTitle("Settings:")
    settingsContainer:SetFullWidth(true)
    settingsContainer:SetLayout("Flow")

    container:AddChild(settingsContainer)

    local leftSettings = AceGUI:Create("SimpleGroup")
    local rightSettings = AceGUI:Create("SimpleGroup")
    leftSettings:SetWidth(180)
    leftSettings:SetLayout("Flow")
    rightSettings:SetWidth(180)
    rightSettings:SetLayout("Flow")
    settingsContainer:AddChild(leftSettings)
    settingsContainer:AddChild(rightSettings)

    local itemScanningCheckBox = AceGUI:Create("CheckBox")
    --itemScanningCheckBox:SetWidth(100)
    itemScanningCheckBox:SetValue(ClassicRaidAssist.db.char.allowItemScanning)
    itemScanningCheckBox:SetLabel("Cкан расходников")
    itemScanningCheckBox:SetCallback("OnValueChanged", function() ClassicRaidAssist.db.char.allowItemScanning = not ClassicRaidAssist.db.char.allowItemScanning end)

    leftSettings:AddChild(itemScanningCheckBox)
	
	local goldOption = AceGUI:Create("CheckBox")
    --itemScanningCheckBox:SetWidth(100)
    goldOption:SetValue(ClassicRaidAssist.db.char.goldCheck)
    goldOption:SetLabel("Cкан золота")
    goldOption:SetCallback("OnValueChanged", function() ClassicRaidAssist.db.char.goldCheck = not ClassicRaidAssist.db.char.goldCheck end)

    rightSettings:AddChild(goldOption)
    
    local smartBuffFilteringOption = AceGUI:Create("CheckBox")
    --itemScanningCheckBox:SetWidth(100)
    smartBuffFilteringOption:SetValue(ClassicRaidAssist.db.char.smartBuffFiltering)
    smartBuffFilteringOption:SetLabel("Умный фильтр бафов")
    smartBuffFilteringOption:SetCallback("OnValueChanged", function() ClassicRaidAssist.db.char.smartBuffFiltering = not ClassicRaidAssist.db.char.smartBuffFiltering end)

    rightSettings:AddChild(smartBuffFilteringOption)

	local itemScanningCheckBox = AceGUI:Create("CheckBox")
	--itemScanningCheckBox:SetWidth(100)
    itemScanningCheckBox:SetValue(ClassicRaidAssist.db.char.consumablesCount)
    itemScanningCheckBox:SetLabel("Показывать количество")
    itemScanningCheckBox:SetCallback("OnValueChanged", function() ClassicRaidAssist.db.char.consumablesCount = not ClassicRaidAssist.db.char.consumablesCount end)

    leftSettings:AddChild(itemScanningCheckBox)	

	local itemScanningCheckBox = AceGUI:Create("CheckBox")
    itemScanningCheckBox:SetValue(ClassicRaidAssist.db.char.showLootInToolTip)
    itemScanningCheckBox:SetLabel("Показывать лут")
    itemScanningCheckBox:SetCallback("OnValueChanged", function() ClassicRaidAssist.db.char.showLootInToolTip = not ClassicRaidAssist.db.char.showLootInToolTip end)

    leftSettings:AddChild(itemScanningCheckBox)
	
    local checkBoxGroup = AceGUI:Create("SimpleGroup")
    local dropdownGroup = AceGUI:Create("SimpleGroup")
    checkBoxGroup:SetWidth(295)
    checkBoxGroup:SetLayout("Flow")
    dropdownGroup:SetWidth(85)
    dropdownGroup:SetLayout("Flow")
    settingsContainer:AddChild(checkBoxGroup)
    settingsContainer:AddChild(dropdownGroup)

    
    local readyCheckOption = AceGUI:Create("CheckBox")
    readyCheckOption:SetFullWidth(true)
    readyCheckOption:SetValue(ClassicRaidAssist.db.char.readyCheckOutput)
    readyCheckOption:SetLabel("При проверке рейда выводить бафы (только Raid Assist)")
    readyCheckOption:SetCallback("OnValueChanged", function() ClassicRaidAssist.db.char.readyCheckOutput = not ClassicRaidAssist.db.char.readyCheckOutput end)

    checkBoxGroup:AddChild(readyCheckOption)

    local reportDropdown = AceGUI:Create("Dropdown")
    reportDropdown:SetFullWidth(true)
    reportDropdown:SetList(GetChatChannels())
    reportDropdown:SetValue(ClassicRaidAssist.db.char.CurrentReadyCheckOutputChannel)
    reportDropdown:SetCallback("OnValueChanged", function(widget, event, key)
        ClassicRaidAssist.db.char.CurrentReadyCheckOutputChannel = key
    end)
    dropdownGroup:AddChild(reportDropdown)

	local versionGroup = AceGUI:Create("SimpleGroup")
    versionGroup:SetFullWidth(true)
    versionGroup:SetHeight(400)
    versionGroup:SetLayout("Flow")

    local scanBtn = AceGUI:Create("Button")
    scanBtn:SetText("Проверить версии")
    scanBtn:SetWidth(200)
    if not (IsInGroup() or IsInRaid()) then
        scanBtn:SetDisabled(true)
        scanBtn:SetText("Нельзя сканировать вне группы")
    end
    scanBtn:SetCallback("OnClick", function()
        ClassicRaidAssist:Scan()
        ClassicRaidAssist.db.char.settingsContainer = container
        container:ReleaseChildren()
        GUI:DrawSettings(container)
    end)
    versionGroup:AddChild(scanBtn)
	
	local scanBtn = AceGUI:Create("Button")
    scanBtn:SetText("Отчет")
    scanBtn:SetWidth(100)
    if not (IsInGroup() or IsInRaid()) then
        scanBtn:SetDisabled(true)
        scanBtn:SetText("Нельзя отправить отчет вне группы")
    end
    scanBtn:SetCallback("OnClick", function()
        GUI:outputVersions(ClassicRaidAssist.db.char.CurrentCheckVersionOutputChannel)		
    end)
    versionGroup:AddChild(scanBtn)

	local dropdownGroup = AceGUI:Create("SimpleGroup")
    dropdownGroup:SetWidth(85)
    dropdownGroup:SetLayout("Flow")
    
	local reportDropdown = AceGUI:Create("Dropdown")
    reportDropdown:SetFullWidth(true)
    reportDropdown:SetList(GetChatChannels())
    reportDropdown:SetValue(ClassicRaidAssist.db.char.CurrentCheckVersionOutputChannel)
    reportDropdown:SetCallback("OnValueChanged", function(widget, event, key)
        ClassicRaidAssist.db.char.CurrentCheckVersionOutputChannel = key
    end)
	dropdownGroup:AddChild(reportDropdown)
	versionGroup:AddChild(dropdownGroup)
		
	container:AddChild(versionGroup)
	
    local scrollContainer = AceGUI:Create("SimpleGroup")
    scrollContainer:SetFullWidth(true)
    scrollContainer:SetHeight(180)
    scrollContainer:SetLayout("Fill")

    local scroll = AceGUI:Create("ScrollFrame")
    scroll:SetLayout("Flow")
    scrollContainer:AddChild(scroll)

    local raidContainer = AceGUI:Create("SimpleGroup")
    
    scroll:AddChild(raidContainer)

    local leftContainer = AceGUI:Create("SimpleGroup")
    local rightContainer = AceGUI:Create("SimpleGroup")
    raidContainer:SetFullWidth(true)
    raidContainer:SetLayout("Flow")
    leftContainer:SetWidth(180)
    leftContainer:SetLayout("Flow")
    rightContainer:SetWidth(180)
    rightContainer:SetLayout("Flow")
    currentCount = 0
	
	name, realm = UnitName("player")
	
    for i = 1, MAX_RAID_MEMBERS do
        local tempPlayerName, _, _, _, class, englishClass = GetRaidRosterInfo(i)
        if(tempPlayerName ~= nil and class ~= nil) then
            currentCount = currentCount + 1
            local currPlayerName, currPlayerRealm = UnitName(tempPlayerName)
            local playerContainer = AceGUI:Create("SimpleGroup")
            playerContainer:SetLayout("Flow")
            playerContainer:SetWidth(180)

            local curr_name = AceGUI:Create("Label")
            curr_name:SetWidth(80)
            curr_name:SetText("|c" .. RAID_CLASS_COLORS[englishClass].colorStr .. currPlayerName .. "|r")

            local status = AceGUI:Create("Label")
            status:SetWidth(80)
            
            if(ClassicRaidAssist.raid[currPlayerName] == nil) then
                status:SetText("|cffff0000ОТСУТСТВУЕТ|r")
            elseif(ClassicRaidAssist.raid[currPlayerName] ~= version) then
                status:SetText("|cffffff00" .. ClassicRaidAssist.raid[currPlayerName] .. "|r")
				if (currPlayerName == name) then
					print("Classic Raid Assist ZG. Необходимо обновить аддон")
				end	
            elseif(ClassicRaidAssist.raid[currPlayerName] == version) then
                status:SetText("|cff00b300" .. ClassicRaidAssist.raid[currPlayerName] .. "|r")
            end
            playerContainer:AddChild(curr_name)
            playerContainer:AddChild(status)
            if(i <= 20) then
                leftContainer:AddChild(playerContainer)
            else
                rightContainer:AddChild(playerContainer)
            end
        end
    end
    
    -- Keep spacing in scan raid tab, fill in with blanks
    if(currentCount <= 20) then
        for i = currentCount, 20 do
            local playerContainer = AceGUI:Create("SimpleGroup")
            playerContainer:SetLayout("Flow")
            playerContainer:SetWidth(200)

            local curr_name = AceGUI:Create("Label")
            curr_name:SetWidth(100)
            curr_name:SetText(" ")
            playerContainer:AddChild(curr_name)
            leftContainer:AddChild(playerContainer)
        end
    else
        for i = currentCount, 39 do
            local playerContainer = AceGUI:Create("SimpleGroup")
            playerContainer:SetLayout("Flow")
            playerContainer:SetWidth(200)

            local curr_name = AceGUI:Create("Label")
            curr_name:SetWidth(100)
            curr_name:SetText(" ")
            playerContainer:AddChild(curr_name)
            rightContainer:AddChild(playerContainer)
        end
    end

    raidContainer:AddChild(leftContainer)
    raidContainer:AddChild(rightContainer)
    container:AddChild(scrollContainer)
end

function GUI:outputVersions(channel)
	
	local stringComposeMissing = ""
	local stringComposeOld = "" 
	
    for i = 1, MAX_RAID_MEMBERS do
        local tempPlayerName, _, _, _, class, englishClass = GetRaidRosterInfo(i)
        if(tempPlayerName ~= nil and class ~= nil) then
            currentCount = currentCount + 1
            local currPlayerName, currPlayerRealm = UnitName(tempPlayerName)
         
            if(ClassicRaidAssist.raid[currPlayerName] == nil) then               
					
				stringToAdd = currPlayerName
                if (string.len(stringComposeMissing) + string.len(stringToAdd) ) >= 255 then
                       					   
					CRA_SendChatMessage("[Classic Raid Assist ZG] Требуется установить участникам: ", channel)
					CRA_SendChatMessage(stringComposeMissing, channel)
					stringComposeMissing = ""
					   				   
                end
                stringComposeMissing = stringComposeMissing .. " " .. stringToAdd 
								
            elseif(ClassicRaidAssist.raid[currPlayerName] ~= version) then
				
				stringToAdd = currPlayerName
                if (string.len(stringComposeOld) + string.len(stringToAdd) ) >= 255 then
                       					   
					CRA_SendChatMessage("[Classic Raid Assist ZG] Требуется обновить участникам: ", channel)
					CRA_SendChatMessage(stringComposeOld, channel)
					stringComposeOld = ""
					   				   
                end
                stringComposeOld = stringComposeOld .. " " .. stringToAdd
							
            end

        end
    end
	
	if (string.len(stringComposeMissing)) > 0 then
		CRA_SendChatMessage("[Classic Raid Assist ZG] Требуется установить участникам: ", channel)
		CRA_SendChatMessage(stringComposeMissing, channel)
	end
	
	if (string.len(stringComposeOld)) > 0 then
		CRA_SendChatMessage("[Classic Raid Assist ZG] Требуется обновить участникам: ", channel)
		CRA_SendChatMessage(stringComposeOld, channel)
	end
	
end

local function SelectGroup(container, event, group)
    container:ReleaseChildren()
    ClassicRaidAssist.db.char.currentTab = group
    if group == "settings" then
        GUI:DrawSettings(container)
    elseif group == "raidBuffs" then
        RaidBuffsTab:DrawRaidBuffs(container)
    elseif group == "worldBuffs" then
        WorldBuffsTab:DrawWorldBuffs(container)
    elseif group == "paladinBuffs" then
        PaladinBuffsTab:DrawPaladinBuffs(container)
    elseif group == "raidItems" then
        RaidItemsTab:DrawRaidItems(container)
    elseif group == "consumables" then
        ConsumablesTab:DrawConsumables(container)
	elseif group == "stats" then
        StatsTab:DrawStats(container)	
    end
end

function GUI:SetUpGUI()
    frame = AceGUI:Create("Frame")
    _G["ClassicRaidAssistGUI_frame"] = frame
    frame:Hide()
    frame:EnableResize(false)
    frame:SetWidth(460)
    frame:SetTitle("Classic Raid Assist ZG")
    frame:SetStatusText("v" .. ClassicRaidAssist.version .. " Spec: " .. ClassicRaidAssist.thisPlayerSpec .. " Class: " .. ClassicRaidAssist.thisPlayerClass)
    tinsert(UISpecialFrames, "ClassicRaidAssistGUI_frame")
    frame:SetLayout("Fill")
    tabGroup = AceGUI:Create("TabGroup")
    
    if (ClassicRaidAssist.faction == "Horde") then
        tabGroup:SetTabs({
            {value = "raidBuffs", text = "Рейд бафы" },
            {value = "worldBuffs", text = "Мировые бафы" },
            {value = "raidItems", text = "Сканирование рейда" },
            {value = "consumables", text = "Расходники" },
			{value = "stats", text = "Характеристики" },
            {value = "settings", text = "Настройки" },
			
        })
    else
        tabGroup:SetTabs({
            {value = "raidBuffs", text = "Рейд бафы" },
            {value = "worldBuffs", text = "Мировые бафы" },
            {value = "paladinBuffs", text = "Бафы паладинов" },
            {value = "raidItems", text = "Сканирование рейда" },
            {value = "consumables", text = "Расходники" },
			{value = "stats", text = "Характеристики" },
            {value = "settings", text = "Настройки" },
			
        })
    end
    tabGroup:SetCallback("OnGroupSelected", SelectGroup)
    tabGroup:SelectTab(ClassicRaidAssist.db.char.currentTab)
    frame:AddChild(tabGroup)
end