
local StatsTab =  {}
_G["StatsTab"] = StatsTab

local AceGUI = LibStub("AceGUI-3.0")
  
local specs = {
    ["Rogue"] = {
        ["englishClass"] = "ROGUE",
		["currentStats"] = {},
        ["stats"] = {
			["Agility"] = {
                ["icon"] = "Interface\\Icons\\inv_scroll_02",
                ["id"] = "Agility",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["Strength"] = {
                ["icon"] = "Interface\\Icons\\spell_nature_strength",
                ["id"] = "Strength",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["Stamina"] = {
                ["icon"] = "Interface\\Icons\\inv_scroll_07",
                ["id"] = "Stamina",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			--["Intellect"] = {
            --    ["icon"] = "Interface\\Icons\\spell_holy_magicalsentry",
            --    ["id"] = "Intellect",
            --    ["checked"] = true,
            --    ["toolTip"] = nil
            --},
			--["Spirit"] = {
            --    ["icon"] = "Interface\\Icons\\spell_holy_divinespirit",
            --    ["id"] = "Spirit",
            --    ["checked"] = true,
            --    ["toolTip"] = nil
            --},
			["Crit"] = {
                ["icon"] = "Interface\\Icons\\spell_nature_unyeildingstamina",
                ["id"] = "Crit",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["AP"] = {
                ["icon"] = "Interface\\Icons\\spell_nature_undyingstrength",
                ["id"] = "AP",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["Hit"] = {
                ["icon"] = "Interface\\Icons\\inv_misc_spyglass_02",
                ["id"] = "Hit",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["Skill"] = {
                ["icon"] = "Interface\\Icons\\ability_warrior_punishingblow",
                ["id"] = "Skill",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			--["RangedSkill"] = {
            --    ["icon"] = "Interface\\Icons\\inv_weapon_rifle_06",
            --    ["id"] = "RangedSkill",
            --    ["checked"] = true,
            --    ["toolTip"] = nil
            --},
			--["RangedCrit"] = {
            --    ["icon"] = "Interface\\Icons\\ability_searingarrow",
            --    ["id"] = "RangedCrit",
            --    ["checked"] = true,
            --    ["toolTip"] = nil
            --},
			--["RangedAP"] = {
            --    ["icon"] = "Interface\\Icons\\ability_piercedamage",
            --    ["id"] = "RangedAP",
            --    ["checked"] = true,
            --    ["toolTip"] = nil
            --},
			--["RangedHit"] = {
            --    ["icon"] = "Interface\\Icons\\ability_townwatch",
            --    ["id"] = "RangedHit",
            --    ["checked"] = true,
             --   ["toolTip"] = nil
            --},
			--["HealSpd"] = {
            --    ["icon"] = "Interface\\Icons\\spell_holy_purify",
            --    ["id"] = "HealSpd",
            --    ["checked"] = true,
            --    ["toolTip"] = nil
            --},
			--["mp2/5cast"] = {
            --    ["icon"] = "Interface\\Icons\\spell_shadow_siphonmana",
            --    ["id"] = "mp2/5cast",
            --    ["checked"] = true,
            --    ["toolTip"] = nil
            --},
			--["mp2/5nocast"] = {
            --    ["icon"] = "Interface\\Icons\\inv_enchant_essenceeternallarge",
            --    ["id"] = "mp2/5nocast",
            --    ["checked"] = true,
            --    ["toolTip"] = nil
            --},
			--["ShadowSpd"] = {
            --    ["icon"] = "Interface\\Icons\\spell_shadow_shadowbolt",
            --    ["id"] = "ShadowSpd",
            --    ["checked"] = true,
            --    ["toolTip"] = nil
            --},
			["NatureSpd"] = {
                ["icon"] = "Interface\\Icons\\spell_nature_moonglow",
                ["id"] = "NatureSpd",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["SpellCrit"] = {
                ["icon"] = "Interface\\Icons\\spell_nature_wispheal",
                ["id"] = "SpellCrit",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			--["FrostSPD"] = {
            --    ["icon"] = "Interface\\Icons\\spell_frost_chillingblast",
            --    ["id"] = "FrostSPD",
            --    ["checked"] = true,
            --    ["toolTip"] = nil
            --},
			--["SpellHit"] = {
            --    ["icon"] = "Interface\\Icons\\inv_wand_01",
            --    ["id"] = "SpellHit",
            --    ["checked"] = true,
            --    ["toolTip"] = nil
            --},			
			--["HolySpd"] = {
            --    ["icon"] = "Interface\\Icons\\spell_holy_holysmite",
            --    ["id"] = "HolySpd",
            --    ["checked"] = true,
            --    ["toolTip"] = nil
            --},
			--["FireSpd"] = {
            --    ["icon"] = "Interface\\Icons\\spell_fire_fireball02",
            --    ["id"] = "FireSpd",
            --    ["checked"] = true,
            --    ["toolTip"] = nil
            --},
			--["ArcaneSpd"] = {
            --    ["icon"] = "Interface\\Icons\\spell_frost_iceshock",
            --    ["id"] = "ArcaneSpd",
            --    ["checked"] = true,
            --    ["toolTip"] = nil
            --},			
			--["Dodge"] = {
            --    ["icon"] = "Interface\\Icons\\spell_magic_lesserinvisibilty",
            --    ["id"] = "Dodge",
            --    ["checked"] = true,
            --    ["toolTip"] = nil
            --},
			--["Parry"] = {
            --    ["icon"] = "Interface\\Icons\\spell_holy_blessingofstrength",
            --    ["id"] = "Parry",
            --    ["checked"] = true,
            --    ["toolTip"] = nil
            --},
			--["BlockChance"] = {
            --    ["icon"] = "Interface\\Icons\\ability_defend",
            --    ["id"] = "BlockChance",
            --    ["checked"] = true,
            --    ["toolTip"] = nil
            --},
			--["BlockValue"] = {
            --    ["icon"] = "Interface\\Icons\\inv_shield_05",
            --    ["id"] = "BlockValue",
            --    ["checked"] = true,
            --    ["toolTip"] = nil
            --},
			--["Defense"] = {
            --    ["icon"] = "Interface\\Icons\\spell_nature_mirrorimage",
            --    ["id"] = "Defense",
            --    ["checked"] = true,
            --    ["toolTip"] = nil
            --},
			--["ArmorValue"] = {
            --    ["icon"] = "Interface\\Icons\\spell_holy_devotion",
            --    ["id"] = "ArmorValue",
            --    ["checked"] = true,
            --    ["toolTip"] = nil
            --},
			--["ArmorReduction"] = {
             --   ["icon"] = "Interface\\Icons\\ability_warrior_shieldwall",
            --    ["id"] = "ArmorReduction",
            --    ["checked"] = true,
            --    ["toolTip"] = nil
            --},		
		},
	},
	["Warrior"] = {
        ["englishClass"] = "WARRIOR",
		["currentStats"] = {},
        ["stats"] = {
			["Agility"] = {
                ["icon"] = "Interface\\Icons\\inv_scroll_02",
                ["id"] = "Agility",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["Strength"] = {
                ["icon"] = "Interface\\Icons\\spell_nature_strength",
                ["id"] = "Strength",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["Stamina"] = {
                ["icon"] = "Interface\\Icons\\inv_scroll_07",
                ["id"] = "Stamina",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["Crit"] = {
                ["icon"] = "Interface\\Icons\\spell_nature_unyeildingstamina",
                ["id"] = "Crit",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["AP"] = {
                ["icon"] = "Interface\\Icons\\spell_nature_undyingstrength",
                ["id"] = "AP",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["Hit"] = {
                ["icon"] = "Interface\\Icons\\inv_misc_spyglass_02",
                ["id"] = "Hit",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["Skill"] = {
                ["icon"] = "Interface\\Icons\\ability_warrior_punishingblow",
                ["id"] = "Skill",
                ["checked"] = true,
                ["toolTip"] = nil
            },			
			["Dodge"] = {
                ["icon"] = "Interface\\Icons\\spell_magic_lesserinvisibilty",
                ["id"] = "Dodge",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["Parry"] = {
                ["icon"] = "Interface\\Icons\\spell_holy_blessingofstrength",
                ["id"] = "Parry",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["BlockChance"] = {
                ["icon"] = "Interface\\Icons\\ability_defend",
                ["id"] = "BlockChance",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["BlockValue"] = {
                ["icon"] = "Interface\\Icons\\inv_shield_05",
                ["id"] = "BlockValue",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["Defense"] = {
                ["icon"] = "Interface\\Icons\\spell_nature_mirrorimage",
                ["id"] = "Defense",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["ArmorValue"] = {
                ["icon"] = "Interface\\Icons\\spell_holy_devotion",
                ["id"] = "ArmorValue",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["ArmorReduction"] = {
                ["icon"] = "Interface\\Icons\\ability_warrior_shieldwall",
                ["id"] = "ArmorReduction",
                ["checked"] = true,
                ["toolTip"] = nil
            },					
		},
	},		
	["Mage"] = {
        ["englishClass"] = "MAGE",
		["currentStats"] = {},
        ["stats"] = {					
			["Stamina"] = {
                ["icon"] = "Interface\\Icons\\inv_scroll_07",
                ["id"] = "Stamina",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["Intellect"] = {
                ["icon"] = "Interface\\Icons\\spell_holy_magicalsentry",
                ["id"] = "Intellect",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["Spirit"] = {
                ["icon"] = "Interface\\Icons\\spell_holy_divinespirit",
                ["id"] = "Spirit",
                ["checked"] = true,
                ["toolTip"] = nil
            },			
			["mp2/5cast"] = {
                ["icon"] = "Interface\\Icons\\spell_shadow_siphonmana",
                ["id"] = "mp2/5cast",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["mp2/5nocast"] = {
                ["icon"] = "Interface\\Icons\\inv_enchant_essenceeternallarge",
                ["id"] = "mp2/5nocast",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["SpellCrit"] = {
                ["icon"] = "Interface\\Icons\\spell_nature_wispheal",
                ["id"] = "SpellCrit",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["FrostSPD"] = {
                ["icon"] = "Interface\\Icons\\spell_frost_chillingblast",
                ["id"] = "FrostSPD",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["SpellHit"] = {
                ["icon"] = "Interface\\Icons\\inv_wand_01",
                ["id"] = "SpellHit",
                ["checked"] = true,
                ["toolTip"] = nil
            },			
			["FireSpd"] = {
                ["icon"] = "Interface\\Icons\\spell_fire_fireball02",
                ["id"] = "FireSpd",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["ArcaneSpd"] = {
                ["icon"] = "Interface\\Icons\\spell_frost_iceshock",
                ["id"] = "ArcaneSpd",
                ["checked"] = true,
                ["toolTip"] = nil
            },									
		},
	},
	["Hunter"] = {
        ["englishClass"] = "HUNTER",
		["currentStats"] = {},
        ["stats"] = {
			["Agility"] = {
                ["icon"] = "Interface\\Icons\\inv_scroll_02",
                ["id"] = "Agility",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["Strength"] = {
                ["icon"] = "Interface\\Icons\\spell_nature_strength",
                ["id"] = "Strength",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["Stamina"] = {
                ["icon"] = "Interface\\Icons\\inv_scroll_07",
                ["id"] = "Stamina",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["Intellect"] = {
                ["icon"] = "Interface\\Icons\\spell_holy_magicalsentry",
                ["id"] = "Intellect",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["Spirit"] = {
                ["icon"] = "Interface\\Icons\\spell_holy_divinespirit",
                ["id"] = "Spirit",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["Crit"] = {
                ["icon"] = "Interface\\Icons\\spell_nature_unyeildingstamina",
                ["id"] = "Crit",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["AP"] = {
                ["icon"] = "Interface\\Icons\\spell_nature_undyingstrength",
                ["id"] = "AP",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["Hit"] = {
                ["icon"] = "Interface\\Icons\\inv_misc_spyglass_02",
                ["id"] = "Hit",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["Skill"] = {
                ["icon"] = "Interface\\Icons\\ability_warrior_punishingblow",
                ["id"] = "Skill",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["RangedSkill"] = {
                ["icon"] = "Interface\\Icons\\inv_weapon_rifle_06",
                ["id"] = "RangedSkill",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["RangedCrit"] = {
                ["icon"] = "Interface\\Icons\\ability_searingarrow",
                ["id"] = "RangedCrit",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["RangedAP"] = {
                ["icon"] = "Interface\\Icons\\ability_piercedamage",
                ["id"] = "RangedAP",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["RangedHit"] = {
                ["icon"] = "Interface\\Icons\\ability_townwatch",
                ["id"] = "RangedHit",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["mp2/5cast"] = {
                ["icon"] = "Interface\\Icons\\spell_shadow_siphonmana",
                ["id"] = "mp2/5cast",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["mp2/5nocast"] = {
                ["icon"] = "Interface\\Icons\\inv_enchant_essenceeternallarge",
                ["id"] = "mp2/5nocast",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["NatureSpd"] = {
                ["icon"] = "Interface\\Icons\\spell_nature_moonglow",
                ["id"] = "NatureSpd",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["SpellCrit"] = {
                ["icon"] = "Interface\\Icons\\spell_nature_wispheal",
                ["id"] = "SpellCrit",
                ["checked"] = true,
                ["toolTip"] = nil
            },			
			["ArcaneSpd"] = {
                ["icon"] = "Interface\\Icons\\spell_frost_iceshock",
                ["id"] = "ArcaneSpd",
                ["checked"] = true,
                ["toolTip"] = nil
            },			
		},	
	},					
	["Priest"] = {
        ["englishClass"] = "PRIEST",
		["currentStats"] = {},
        ["stats"] = {			
			["Stamina"] = {
                ["icon"] = "Interface\\Icons\\inv_scroll_07",
                ["id"] = "Stamina",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["Intellect"] = {
                ["icon"] = "Interface\\Icons\\spell_holy_magicalsentry",
                ["id"] = "Intellect",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["Spirit"] = {
                ["icon"] = "Interface\\Icons\\spell_holy_divinespirit",
                ["id"] = "Spirit",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["HealSpd"] = {
                ["icon"] = "Interface\\Icons\\spell_holy_purify",
                ["id"] = "HealSpd",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["mp2/5cast"] = {
                ["icon"] = "Interface\\Icons\\spell_shadow_siphonmana",
                ["id"] = "mp2/5cast",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["mp2/5nocast"] = {
                ["icon"] = "Interface\\Icons\\inv_enchant_essenceeternallarge",
                ["id"] = "mp2/5nocast",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["ShadowSpd"] = {
                ["icon"] = "Interface\\Icons\\spell_shadow_shadowbolt",
                ["id"] = "ShadowSpd",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["SpellCrit"] = {
                ["icon"] = "Interface\\Icons\\spell_nature_wispheal",
                ["id"] = "SpellCrit",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["SpellHit"] = {
                ["icon"] = "Interface\\Icons\\inv_wand_01",
                ["id"] = "SpellHit",
                ["checked"] = true,
                ["toolTip"] = nil
            },			
			["HolySpd"] = {
                ["icon"] = "Interface\\Icons\\spell_holy_holysmite",
                ["id"] = "HolySpd",
                ["checked"] = true,
                ["toolTip"] = nil
            },		
		},	
	},	
	["Warlock"] = {
        ["englishClass"] = "WARLOCK",
		["currentStats"] = {},
        ["stats"] = {		
			["Stamina"] = {
                ["icon"] = "Interface\\Icons\\inv_scroll_07",
                ["id"] = "Stamina",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["Intellect"] = {
                ["icon"] = "Interface\\Icons\\spell_holy_magicalsentry",
                ["id"] = "Intellect",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["Spirit"] = {
                ["icon"] = "Interface\\Icons\\spell_holy_divinespirit",
                ["id"] = "Spirit",
                ["checked"] = true,
                ["toolTip"] = nil
            },			
			["mp2/5cast"] = {
                ["icon"] = "Interface\\Icons\\spell_shadow_siphonmana",
                ["id"] = "mp2/5cast",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["mp2/5nocast"] = {
                ["icon"] = "Interface\\Icons\\inv_enchant_essenceeternallarge",
                ["id"] = "mp2/5nocast",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["ShadowSpd"] = {
                ["icon"] = "Interface\\Icons\\spell_shadow_shadowbolt",
                ["id"] = "ShadowSpd",
                ["checked"] = true,
                ["toolTip"] = nil
            },			
			["SpellCrit"] = {
                ["icon"] = "Interface\\Icons\\spell_nature_wispheal",
                ["id"] = "SpellCrit",
                ["checked"] = true,
                ["toolTip"] = nil
            },			
			["SpellHit"] = {
                ["icon"] = "Interface\\Icons\\inv_wand_01",
                ["id"] = "SpellHit",
                ["checked"] = true,
                ["toolTip"] = nil
            },									
		},
	},		
	["Druid"] = {
        ["englishClass"] = "DRUID",
		["currentStats"] = {},
        ["stats"] = {
			["Agility"] = {
                ["icon"] = "Interface\\Icons\\inv_scroll_02",
                ["id"] = "Agility",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["Strength"] = {
                ["icon"] = "Interface\\Icons\\spell_nature_strength",
                ["id"] = "Strength",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["Stamina"] = {
                ["icon"] = "Interface\\Icons\\inv_scroll_07",
                ["id"] = "Stamina",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["Intellect"] = {
                ["icon"] = "Interface\\Icons\\spell_holy_magicalsentry",
                ["id"] = "Intellect",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["Spirit"] = {
                ["icon"] = "Interface\\Icons\\spell_holy_divinespirit",
                ["id"] = "Spirit",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["Crit"] = {
                ["icon"] = "Interface\\Icons\\spell_nature_unyeildingstamina",
                ["id"] = "Crit",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["AP"] = {
                ["icon"] = "Interface\\Icons\\spell_nature_undyingstrength",
                ["id"] = "AP",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["Hit"] = {
                ["icon"] = "Interface\\Icons\\inv_misc_spyglass_02",
                ["id"] = "Hit",
                ["checked"] = true,
                ["toolTip"] = nil
            },			
			["HealSpd"] = {
                ["icon"] = "Interface\\Icons\\spell_holy_purify",
                ["id"] = "HealSpd",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["mp2/5cast"] = {
                ["icon"] = "Interface\\Icons\\spell_shadow_siphonmana",
                ["id"] = "mp2/5cast",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["mp2/5nocast"] = {
                ["icon"] = "Interface\\Icons\\inv_enchant_essenceeternallarge",
                ["id"] = "mp2/5nocast",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["NatureSpd"] = {
                ["icon"] = "Interface\\Icons\\spell_nature_moonglow",
                ["id"] = "NatureSpd",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["SpellCrit"] = {
                ["icon"] = "Interface\\Icons\\spell_nature_wispheal",
                ["id"] = "SpellCrit",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["SpellHit"] = {
                ["icon"] = "Interface\\Icons\\inv_wand_01",
                ["id"] = "SpellHit",
                ["checked"] = true,
                ["toolTip"] = nil
            },			
			["ArcaneSpd"] = {
                ["icon"] = "Interface\\Icons\\spell_frost_iceshock",
                ["id"] = "ArcaneSpd",
                ["checked"] = true,
                ["toolTip"] = nil
            },			
			["Dodge"] = {
                ["icon"] = "Interface\\Icons\\spell_magic_lesserinvisibilty",
                ["id"] = "Dodge",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["Defense"] = {
                ["icon"] = "Interface\\Icons\\spell_nature_mirrorimage",
                ["id"] = "Defense",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["ArmorValue"] = {
                ["icon"] = "Interface\\Icons\\spell_holy_devotion",
                ["id"] = "ArmorValue",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["ArmorReduction"] = {
                ["icon"] = "Interface\\Icons\\ability_warrior_shieldwall",
                ["id"] = "ArmorReduction",
                ["checked"] = true,
                ["toolTip"] = nil
            },
		},
	},
	["Shaman"] = {
        ["englishClass"] = "SHAMAN",
		["currentStats"] = {},
        ["stats"] = {
			["Agility"] = {
                ["icon"] = "Interface\\Icons\\inv_scroll_02",
                ["id"] = "Agility",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["Strength"] = {
                ["icon"] = "Interface\\Icons\\spell_nature_strength",
                ["id"] = "Strength",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["Stamina"] = {
                ["icon"] = "Interface\\Icons\\inv_scroll_07",
                ["id"] = "Stamina",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["Intellect"] = {
                ["icon"] = "Interface\\Icons\\spell_holy_magicalsentry",
                ["id"] = "Intellect",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["Spirit"] = {
                ["icon"] = "Interface\\Icons\\spell_holy_divinespirit",
                ["id"] = "Spirit",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["Crit"] = {
                ["icon"] = "Interface\\Icons\\spell_nature_unyeildingstamina",
                ["id"] = "Crit",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["AP"] = {
                ["icon"] = "Interface\\Icons\\spell_nature_undyingstrength",
                ["id"] = "AP",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["Hit"] = {
                ["icon"] = "Interface\\Icons\\inv_misc_spyglass_02",
                ["id"] = "Hit",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["Skill"] = {
                ["icon"] = "Interface\\Icons\\ability_warrior_punishingblow",
                ["id"] = "Skill",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["HealSpd"] = {
                ["icon"] = "Interface\\Icons\\spell_holy_purify",
                ["id"] = "HealSpd",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["mp2/5cast"] = {
                ["icon"] = "Interface\\Icons\\spell_shadow_siphonmana",
                ["id"] = "mp2/5cast",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["mp2/5nocast"] = {
                ["icon"] = "Interface\\Icons\\inv_enchant_essenceeternallarge",
                ["id"] = "mp2/5nocast",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["NatureSpd"] = {
                ["icon"] = "Interface\\Icons\\spell_nature_moonglow",
                ["id"] = "NatureSpd",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["SpellCrit"] = {
                ["icon"] = "Interface\\Icons\\spell_nature_wispheal",
                ["id"] = "SpellCrit",
                ["checked"] = true,
                ["toolTip"] = nil
            },
			["SpellHit"] = {
                ["icon"] = "Interface\\Icons\\inv_wand_01",
                ["id"] = "SpellHit",
                ["checked"] = true,
                ["toolTip"] = nil
            },						
		},
	},
}			
  
function StatsTab:getStats()
    return specs
end 
  
local function OnValueChanged(stat)
    local currSpec = ClassicRaidAssist.db.char.currentSpecStatsTab
    if(ClassicRaidAssist.db.char.statsToCheckFor[currSpec][stat] == false or ClassicRaidAssist.db.char.statsToCheckFor[currSpec][stat] == nil) then
        ClassicRaidAssist.db.char.statsToCheckFor[currSpec][stat] = true
    else
        ClassicRaidAssist.db.char.statsToCheckFor[currSpec][stat] = false
    end
end

local function DrawClassStats()
														
	local currentSpec = ClassicRaidAssist.db.char.currentSpecStatsTab
    local raidContainer = AceGUI:Create("SimpleGroup")
    raidContainer:SetFullWidth(true)
    raidContainer:SetLayout("Flow")

    local groupContainer = AceGUI:Create("SimpleGroup")
    groupContainer:SetRelativeWidth(1)
    groupContainer:SetLayout("List")
    groupContainer:SetFullWidth(true)

    local currentTypeIteration = {}

    currentTypeIteration = specs[currentSpec]['currentStats']

    local spellsPerRow = 5
    local currentSpells = 0

    for key, value in pairs(currentTypeIteration) do
        local playerContainer = AceGUI:Create("SimpleGroup")
        playerContainer:SetLayout("Flow")
        playerContainer:SetFullWidth(true)

        local spellContainer = nil
        local currName = AceGUI:Create("Label")
        currName:SetWidth(80)
        currName:SetText("|c" .. RAID_CLASS_COLORS[specs[currentSpec]['englishClass']].colorStr .. key .. "|r")

        spellContainer = AceGUI:Create("SimpleGroup")
        spellContainer:SetLayout("Flow")
        spellContainer:SetFullWidth(true)

        spellContainer:AddChild(currName)

        currentSpells = 0
        for spellName, hasConsume in pairs(value) do
            if(spellContainer == nil or currentSpells > spellsPerRow) then

                currName = AceGUI:Create("Label")
                currName:SetWidth(80)

                if(currentSpells >= spellsPerRow) then
                    currentSpells = 0
                    playerContainer:AddChild(spellContainer)
                else
                    currName:SetText("|c" .. RAID_CLASS_COLORS[specs[currentSpec]['englishClass']].colorStr .. key .. "|r")
                end

                spellContainer = AceGUI:Create("SimpleGroup")
                spellContainer:SetLayout("Flow")
                spellContainer:SetFullWidth(true)

                spellContainer:AddChild(currName)
               end
            local currSpell = AceGUI:Create("Icon")
            if(hasConsume == "-1") then
                currSpell:SetImage("Interface\\Icons\\inv_misc_questionmark")
            else
                currSpell:SetImage(specs[currentSpec]['stats'][spellName]["icon"])
            end
            currSpell:SetImageSize("16", "16")
            currSpell.image:SetAllPoints()
            currSpell:SetWidth(16)
            currSpell:SetHeight(16)

            currSpell.frame:SetScript("OnEnter", function()
                if(specs[currentSpec]['stats'][spellName]['toolTip'] == nil) then
                    specs[currentSpec]['stats'][spellName]['toolTip'] = CreateFrame( "GameTooltip", spellName .. currentSpec .. currentSpec .. key, nil, "GameTooltipTemplate" )
                end
                MyToolTip = specs[currentSpec]['stats'][spellName]['toolTip']
                MyToolTip:SetOwner(WorldFrame, "ANCHOR_CURSOR")
                MyToolTip:SetText(specs[currentSpec]['stats'][spellName]['id'])
                MyToolTip:Show() 
            end)
            currSpell.frame:SetScript("OnLeave", function() 
                MyToolTip:Hide() 
            end)

            if hasConsume == "0" then
                currSpell.image:SetVertexColor(1, 1, 1, 0.3)
            else
                currSpell.image:SetVertexColor(1, 1, 1, 1)
            end
			
			local count = AceGUI:Create("Label")
			count:SetWidth(30)
			count:SetText(hasConsume)
			
            currentSpells = currentSpells + 1
            
            local spacer = AceGUI:Create("Label")
            spacer:SetWidth(2)

            spellContainer:AddChild(currSpell)
			spellContainer:AddChild(count)
            spellContainer:AddChild(spacer)
            -- end
        end
        playerContainer:AddChild(spellContainer)
        groupContainer:AddChild(playerContainer)
    end
    raidContainer:AddChild(groupContainer)
    return raidContainer
end

local function drawStatsClassTab(spec)

	local rowSize = 6
    local spacerWidth = 10
    local tabWidth = 385
    local fullTab = AceGUI:Create("SimpleGroup")
    fullTab:SetWidth(tabWidth)
    fullTab:SetLayout("Flow")

    local totalstats = 0
    for key, value in pairs(specs[spec]['stats']) do
        totalstats = totalstats + 1
    end
    local remainingstats = totalstats

    if(totalstats % rowSize == 1 or totalstats % rowSize == 2) then
        rowSize = rowSize - 1
    end
        
    if(totalstats % rowSize == 1 or totalstats % rowSize == 2) then
        rowSize = rowSize + 2
    end

    local totalWidth = (tabWidth-30-spacerWidth)/(rowSize)

    local statsCheckBoxRows = {}
    local statsCheckBox = AceGUI:Create("InlineGroup")
    statsCheckBox:SetTitle("Проверить характеристики:")
    statsCheckBox:SetFullWidth(true)
    statsCheckBox:SetLayout("Flow")

    local statsCheckBoxRow = nil

    local currentRowSize = 0
    for stat, statValues in pairs(specs[spec]['stats']) do
            if(currentRowSize >= rowSize or currentRowSize == 0) then
                if(statsCheckBoxRow ~= nil) then
                    remainingstats = remainingstats - rowSize
                    table.insert(statsCheckBoxRows, statsCheckBoxRow)
                end
                if remainingstats < rowSize then
                    spacerWidth = spacerWidth * (rowSize - remainingstats + 1)
                    totalWidth = (tabWidth-30-spacerWidth)/(remainingstats)
                end
                statsCheckBoxRow = AceGUI:Create("SimpleGroup")
                statsCheckBoxRow:SetFullWidth(true)
                statsCheckBoxRow:SetLayout("Flow")
                
                local spacerGroup = AceGUI:Create("Label")
                spacerGroup:SetWidth(spacerWidth)
                statsCheckBoxRow:AddChild(spacerGroup)
                currentRowSize = 0
            end
            local tempCheckBox = AceGUI:Create("CheckBox")
            tempCheckBox:SetWidth(totalWidth)
            tempCheckBox:SetLabel("")
            tempCheckBox:SetValue(ClassicRaidAssist.db.char.statsToCheckFor[spec][stat])
            tempCheckBox:SetImage(statValues["icon"])
            tempCheckBox:SetCallback("OnValueChanged", function() OnValueChanged(stat) end)
            tempCheckBox:SetCallback("OnEnter", function() 
                if(statValues['toolTip'] == nil) then
                    statValues['toolTip'] = CreateFrame( "GameTooltip", stat .. spec, nil, "GameTooltipTemplate" )
                end
                MyToolTip = statValues['toolTip']
                MyToolTip:SetOwner(tempCheckBox.frame, "ANCHOR_CURSOR")
				MyToolTip:SetText(stat)
                MyToolTip:Show() 
            end)
            tempCheckBox:SetCallback("OnLeave", function() 
                MyToolTip:Hide() 
            end)
            statsCheckBoxRow:AddChild(tempCheckBox)
            currentRowSize = currentRowSize + 1
    end
    table.insert(statsCheckBoxRows, statsCheckBoxRow)
    for key, value in pairs(statsCheckBoxRows) do
        statsCheckBox:AddChild(value)
    end
    fullTab:AddChild(statsCheckBox)
    fullTab:AddChild(DrawClassStats())
    return fullTab

end

function StatsTab:ScanStats(spec)
    
	specs[spec]['currentStats'] = {}
            
    for key, value in pairs(specs[spec]['stats']) do
                
        if(ClassicRaidAssist.db.char.statsToCheckFor[spec][key]) then
              ClassicRaidAssist:StatQuestion(spec, value['id'])
        end
		  
	end
	
end

function StatsTab:DrawStats(container)

	ClassicRaidAssist:ClearCooldowns()

	local SimpleGroup = AceGUI:Create("SimpleGroup")
    SimpleGroup:SetFullWidth(true)
    SimpleGroup:SetLayout("Flow")
	
	local specDropDown = AceGUI:Create("Dropdown")
    specDropDown:SetWidth(150)
    local dropdown = {}
    for key, value in pairs(specs) do
        dropdown[key] = "|c" .. RAID_CLASS_COLORS[value['englishClass']].colorStr .. key
    end
    specDropDown:SetList(dropdown)
    specDropDown:SetValue(ClassicRaidAssist.db.char.currentSpecStatsTab)
    specDropDown:SetCallback("OnValueChanged", function(widget, event, key)
        container:ReleaseChildren()
        ClassicRaidAssist.db.char.currentSpecStatsTab = key
        ClassicRaidAssist.db.char.statsContainer = container
        StatsTab:DrawStats(container)
    end)
    SimpleGroup:AddChild(specDropDown)

	local scanBtn = AceGUI:Create("Button")
    scanBtn:SetText("Сканировать " .. ClassicRaidAssist.db.char.currentSpecStatsTab) --.. " stats")
    scanBtn:SetWidth(200)
    if not (IsInGroup() or IsInRaid()) then
        scanBtn:SetDisabled(true)
        scanBtn:SetText("Нельзя сканировать вне группы")
    end
    scanBtn:SetCallback("OnClick", function()
        container:ReleaseChildren()
        ClassicRaidAssist.db.char.statsContainer = container
        StatsTab:ScanStats(ClassicRaidAssist.db.char.currentSpecStatsTab)		
        StatsTab:DrawStats(container)
    end)
	
	SimpleGroup:AddChild(scanBtn)
	
	container:AddChild(SimpleGroup)
	
	local scrollContainer = AceGUI:Create("SimpleGroup")
    scrollContainer:SetFullWidth(true)
    scrollContainer:SetHeight(300)
    scrollContainer:SetLayout("Fill")

    local scroll = AceGUI:Create("ScrollFrame")
    scroll:SetLayout("Flow")
    scrollContainer:AddChild(scroll)

    local raidContainer = AceGUI:Create("SimpleGroup")
    
    scroll:AddChild(drawStatsClassTab(ClassicRaidAssist.db.char.currentSpecStatsTab))
    container:AddChild(scrollContainer)
    
    local bottomNote = AceGUI:Create("Label")
    bottomNote:SetFullWidth(true)
    bottomNote:SetText("Каждый в рейде должен иметь аддон.")
    container:AddChild(bottomNote)
	
end


